" AutoAlign.vim: a ftplugin for C
" Author:	Charles E. Campbell, Jr.  <NdrOchip@ScampbellPfamily.AbizM>-NOSPAM
" Date:		Jan 14, 2005
" Version:	5	NOT RELEASED
" GetLatestVimScripts: 884  1 :AutoInstall: AutoAlign.vim
" GetLatestVimScripts: 294  1 :AutoInstall: Align.vim
" GetLatestVimScripts: 1066 1 :AutoInstall: cecutil.vim
if exists("b:didautoalign_cpp")
 finish
endif
let b:didautoalign_cpp = 5
"DechoVarOn

" ---------------------------------------------------------------------
" Public Interface: AA toggles AutoAlign {{{1
com! -nargs=0 AA if exists("b:autoalign")|let b:autoalign= !b:autoalign|else|let b:autoalign= 0|endif|echo "AutoAlign is ".(b:autoalign? "on" : "off")

" ---------------------------------------------------------------------
"  overloading '=' to keep things lined up {{{1
ino <silent> = =<ESC>:let b:autoalign_vekeep=&ve<bar>let &ve=""<bar>silent call <sid>AutoAlign_cpp()<bar>let &ve=b:autoalign_vekeep<bar>norm! x<cr>i=
ino <silent> < <<ESC>:let b:autoalign_vekeep=&ve<bar>let &ve=""<bar>silent call <sid>AutoAlign_cpp()<bar>let &ve=b:autoalign_vekeep<bar>norm! x<cr>i<
ino <silent> > ><ESC>:let b:autoalign_vekeep=&ve<bar>let &ve=""<bar>silent call <sid>AutoAlign_cpp()<bar>let &ve=b:autoalign_vekeep<bar>norm! x<cr>i>

" ---------------------------------------------------------------------
"  AutoAlign_cpp: decides when to use Align/AlignMaps's \t= and \a< for alignment
fun! s:AutoAlign_cpp()
"  call Dfunc("AutoAlign_cpp()")
  if exists("b:autoalign") && b:autoalign == 0
"   call Dret("AutoAlign_cpp")
   return
  endif
  set lz

  " handle alignment of "="
  if getline(".") =~ '^\(\s*\h\w*\(\[\d\+]\)\{0,}\(->\|\.\)\=\)\+\s*[-+*/^|%]\=='
   let curposn   = SaveWinPosn()
   let curline   = line(".")
   let nopatline = search('^[^=]\+$','bW')
   call RestoreWinPosn(curposn)
   if exists("b:autoalign_cpp") && line("'a") == b:autoalign_cpp && b:autoalign_cpp < curline && nopatline < line("'a")
"   	call Decho("autoalign= multi")
	let atend= col(".") >= col("$") - 1
    exe "norm! i\<c-g>u\<esc>"
    exe "norm ".g:mapleader."t=$"
	if !atend
	 norm! h
	endif
   else
    let b:autoalign_cpp= line(".")
    ka
"	call Decho("autoalign= start")
   endif

  elseif getline(".") =~ '\(<<\|>>\)'
   let curposn   = SaveWinPosn()
   let curline   = line(".")
   let nopatline = search('^\%(\%(<<\|>>\)\@!.\)*$','bW')
   call RestoreWinPosn(curposn)
   if exists("b:autoalign_cppio") && line("'a") == b:autoalign_cppio && b:autoalign_cppio < curline && nopatline < line("'a")
"   	call Decho("autoalign<< multi")
	let atend= col(".") >= col("$") - 1
    exe "norm! i\<c-g>u\<esc>"
    exe "norm ".g:mapleader."a<$"
	if !atend
	 norm! h
	endif
   else
    let b:autoalign_cppio= line(".")
    ka
"	call Decho("autoalign<< start")
   endif

  elseif exists("b:autoalign_cpp")
   unlet b:autoalign_cpp
"   call Decho("autoalign suspend")
  endif

  set nolz
"  call Dret("AutoAlign_cpp")
endfun

" ---------------------------------------------------------------------
" vim: ts=4 fdm=marker
